#include "main.h"

#define MAX_ENTRY 1024

extern u32 new_pad;

static struct dirent files[MAX_ENTRY];
int nfiles;
/*
int searchFile(const char *path, const char *name) {
	static struct dirent file;
	int fd, ret=0;
	char *p;
	
	fd = sceIoDopen(path);
	for(;;){
		if(sceIoDread(fd, &file)<=0) break;
		if(file.type == TYPE_DIR) continue;
		if(!_strcmp(file.name,name)) ret=1;
	}
	sceIoDclose(fd);
	
	return ret;
}
*/
////////////////////////////////////////////////////////////////////////
// NCbN\[g
int cmpFile(struct dirent *a, struct dirent *b)
{
	char ca, cb;
	int i, n, ret;
	
	if(a->type==b->type){
		n=strlen(a->name);
		for(i=0; i<=n; i++){
			ca=a->name[i]; cb=b->name[i];
			if(ca>='a' && ca<='z') ca-=0x20;
			if(cb>='a' && cb<='z') cb-=0x20;
			
			ret = ca-cb;
			if(ret!=0) return ret;
		}
		return 0;
	}
	
	if(a->type & TYPE_DIR)	return -1;
	else					return 1;
}

void sort(struct dirent *a, int left, int right) {
	struct dirent tmp, pivot;
	int i, p;
	
	if (left < right) {
		pivot = a[left];
		p = left;
		for (i=left+1; i<=right; i++) {
			if (cmpFile(&a[i],&pivot)<0){
				p=p+1;
				tmp=a[p];
				a[p]=a[i];
				a[i]=tmp;
			}
		}
		a[left] = a[p];
		a[p] = pivot;
		sort(a, left, p-1);
		sort(a, p+1, right);
	}
}

void getDir(const char *path) {
	int fd;
	char *p;
	
	fd = sceIoDopen(path);
	nfiles = 0;
	while(nfiles<MAX_ENTRY){
		if(sceIoDread(fd, &files[nfiles])<=0) break;
		if(files[nfiles].name[0] == '.') continue;
		if(files[nfiles].type == TYPE_DIR){
			strcat(files[nfiles].name, "/");
			nfiles++;
			continue;
		}
		if((p=strrchr(files[nfiles].name, '.'))==NULL) continue;
		if(!stricmp("gb",p+1) | !stricmp("gbc",p+1)) nfiles++;
	}
	sceIoDclose(fd);
	sort(files, 0, nfiles-1);
}

char LastPath[MAX_PATH];
int getFilePath(char *out)
{
	unsigned long color;
	int sel=0, rows=21, top=0, x, y, h, i, len;
	char path[MAXPATH], *p;
	
	strcpy(path, LastPath);
	
	getDir(path);
	for(;;){
		readpad();
		if(new_pad & CTRL_CIRCLE){
			if(files[sel].type == TYPE_DIR){
				strcat(path,files[sel].name);
				getDir(path);
				sel=0;
			}else{
				strcpy(out, path);
				strcat(out, files[sel].name);
				strcpy(LastPath,path);
				return 1;
			}
		}else if(new_pad & CTRL_CROSS){
			return 0;
		}else if(new_pad & CTRL_TRIANGLE){
			len = strlen(path);
			path[len-1] = 0;
			p=strrchr(path,'/');
			if(p!=NULL){
				*(p+1)=0;
				getDir(path);
				sel=0;
			}else{
				path[len-1] = '/';
			}
		}else if(new_pad & CTRL_UP){
			sel--;
		}else if(new_pad & CTRL_DOWN){
			sel++;
		}else if(new_pad & CTRL_LEFT){
			sel-=10;
		}else if(new_pad & CTRL_RIGHT){
			sel+=10;
		}
		
		if(top > nfiles-rows)	top=nfiles-rows;
		if(top < 0)				top=0;
		if(sel >= nfiles)		sel=nfiles-1;
		if(sel < 0)				sel=0;
		if(sel >= top+rows)		top=sel-rows+1;
		if(sel < top)			top=sel;
		
		rin_frame(path,"FOK@~FCANCEL@FUP");
		
		// XN[o[
		if(nfiles > rows){
			h = 219;
			pgDrawFrame(445,25,446,248,setting.color[1]);
			pgFillBox(448, h*top/nfiles + 27,
				460, h*(top+rows)/nfiles + 27,setting.color[1]);
		}
		
		x=28; y=32;
		for(i=0; i<rows; i++){
			if(top+i >= nfiles) break;
			if(top+i == sel) color = setting.color[2];
			else			 color = setting.color[3];
			mh_print(x, y, files[top+i].name, color);
			y+=10;
		}
		
		pgScreenFlipV();
	}
}
